
clc
clear all

% load ('..\4Optimal_Allocations\01Baseline.mat') 
load ('..\5Pareto_Improving_Allocations\Baseline\ParetoBaseline.mat') 

b=x(:,1);
h=x(:,2);
y=x(:,3);
s=subsidy';

%% US System  %%
%%%%%%%%%%%%%%%%

% unem=5500/(10*50*n);                                        % Unemployment insurance benefits for single mother with 2 children
unem=556/(10*50*n);                                        % Unemployment insurance benefits for childless person

% exempt=(8400+3650*3)/(10*50*n);                          % Income tax deductions and allowances for single mother with 2 children
exempt=(5700+3650)/(10*50*n);                              % Income tax deductions and allowances for childless person
m1=0.1;                                                     % Marginal income tax rates
m2=0.15;    
m3=0.25;
m4=0.28;
m5=0.33;
m6=0.35;
inc1=8375/(10*50*n);                                        % Income tax thresholds
inc2=34000/(10*50*n);
inc3=82400/(10*50*n);
inc4=171850/(10*50*n);
inc5=373650/(10*50*n);

ssrate=0.08;                                                % Social Security tax rate for employees (note: employees + employers 15.3%)
ssbase=106800/(10*50*n);

% eitcmax=5036/(10*50*n);                                     % Maximum EITC credit for Single parent with two children
% eitcin=0.4;                                                 % Phase in rate
% eitcout=0.21;                                               % Phase out rate
% eitcinc=40363/(10*50*n);                                    % Earnings threshold  
% eitceli=16420/(10*50*n);                                    % Income where phase out start

eitcmax=457/(10*50*n);                                      % Maximum EITC credit for childless parent
eitcin=0.0765;                                              % Phase in rate
eitcout=0.0765;                                             % Phase out rate
eitcinc=13460/(10*50*n);                                    % Earnings threshold  
eitceli=7486/(10*50*n);                                     % Income where phase out start

dctcinc1=15000/(10*50*n);                                   % DCTC income threshold  
dctcinc2=17000/(10*50*n);
dctcinc3=19000/(10*50*n);
dctcinc4=21000/(10*50*n);
dctcinc5=23000/(10*50*n);
dctcinc6=25000/(10*50*n);
dctcinc7=27000/(10*50*n);
dctcinc8=29000/(10*50*n);
dctcinc9=31000/(10*50*n);
dctcinc10=33000/(10*50*n);
dctcinc11=35000/(10*50*n);
dctcinc12=37000/(10*50*n);
dctcinc13=39000/(10*50*n);
dctcinc14=41000/(10*50*n);
dctcinc15=43000/(10*50*n);
dctcrate1=0.35;                                             % DCTC rates
dctcrate2=0.34;
dctcrate3=0.33;
dctcrate4=0.32;
dctcrate5=0.31;
dctcrate6=0.30;
dctcrate7=0.29;
dctcrate8=0.28;
dctcrate9=0.27;
dctcrate10=0.26;
dctcrate11=0.25;
dctcrate12=0.24;
dctcrate13=0.23;
dctcrate14=0.22;
dctcrate15=0.21;
dctcrate16=0.2;
dctcmax=6000/(10*50*n);                                     % DCTC maximum credit

ccdfsub=0.9;                                                % Recommended subsidy rate according to Federal guidelines
ccdfinc1=17568/(10*50*n);                                   % Income thresholds
ccdfinc2=26325/(10*50*n);
ccdfinc3=32349/(10*50*n);
ccdfrate1=0.39;                                             % Proportion receiving the ccdf subsidy
ccdfrate2=0.24;
ccdfrate3=0.05;

%% Computing DCTC and CCDF Subsidy Rates using Optimal earnings
for i=1:N
    % Computing DCTC benefits - Non-refundable tax credit
    if x(i,3)>0.001 & x(i,3)<=dctcinc1
       dctcrate(i)=dctcrate1;
    elseif x(i,3)>dctcinc1 & x(i,3)<=dctcinc2
       dctcrate(i)=dctcrate2;
    elseif x(i,3)>dctcinc2 & x(i,3)<=dctcinc3
       dctcrate(i)=dctcrate3;
    elseif x(i,3)>dctcinc3 & x(i,3)<=dctcinc4
       dctcrate(i)=dctcrate4;
    elseif x(i,3)>dctcinc4 & x(i,3)<=dctcinc5
       dctcrate(i)=dctcrate5;
    elseif x(i,3)>dctcinc5 & x(i,3)<=dctcinc6
       dctcrate(i)=dctcrate6;
    elseif x(i,3)>dctcinc6 & x(i,3)<=dctcinc7
       dctcrate(i)=dctcrate7;
    elseif x(i,3)>dctcinc7 & x(i,3)<=dctcinc8
       dctcrate(i)=dctcrate8;
    elseif x(i,3)>dctcinc8 & x(i,3)<=dctcinc9
       dctcrate(i)=dctcrate9;
    elseif x(i,3)>dctcinc9 & x(i,3)<=dctcinc10
       dctcrate(i)=dctcrate10;
    elseif x(i,3)>dctcinc10 & x(i,3)<=dctcinc11
       dctcrate(i)=dctcrate11;    
    elseif x(i,3)>dctcinc11 & x(i,3)<=dctcinc12
       dctcrate(i)=dctcrate12;
    elseif x(i,3)>dctcinc12 & x(i,3)<=dctcinc13
       dctcrate(i)=dctcrate13;
    elseif x(i,3)>dctcinc13 & x(i,3)<=dctcinc14
       dctcrate(i)=dctcrate14;
    elseif x(i,3)>dctcinc14 & x(i,3)<=dctcinc15
       dctcrate(i)=dctcrate15;
    elseif x(i,3)>dctcinc15
       dctcrate(i)=dctcrate16;
    else
       dctcrate(i)=0;
    end
    % Computing CCDF benefits   
    if x(i,3)>0.001 & x(i,3)<=ccdfinc1
       ccdfrate(i)=ccdfrate1*ccdfsub;
    elseif x(i,3)>ccdfinc1 & x(i,3)<ccdfinc2
       ccdfrate(i)=ccdfrate2*ccdfsub;
    elseif x(i,3)>ccdfinc2 & x(i,3)<ccdfinc3
       ccdfrate(i)=ccdfrate3*ccdfsub;
    else
       ccdfrate(i)=0;
    end 
   subUSA=dctcrate+ccdfrate;
end


%% Computing the Actual Tax Function based on Second Best Allocations

for r=1:N
    % Defining taxable(r) income
    taxable(r)=max(0,(y(r,1)-exempt));
    % Computing Federal taxes
    if taxable(r)>0.01 & taxable(r)<=inc1
        tax(r)=m1*taxable(r);
    elseif taxable(r)>inc1 & taxable(r)<=inc2
        tax(r)=m2*taxable(r);
    elseif taxable(r)>inc2 & taxable(r)<=inc3
        tax(r)=m3*taxable(r);
    elseif taxable(r)>inc3 & taxable(r)<=inc4
        tax(r)=m4*taxable(r);
    elseif taxable(r)>inc4 & taxable(r)<=inc5
        tax(r)=m5*taxable(r);
    elseif taxable(r)>inc5
        tax(r)=m6*taxable(r);
    else
        tax(r)=0;
    end
    % Computing Social Security tax
    ss(r)=min(ssrate*ssbase,ssrate*y(r,1));
    % Computing EITC benefits - Refundable tax credit
    if y(r,1)>0.001 & y(r,1)<eitceli 
       eitc(r)=min(eitcmax,eitcin*y(r,1));
    elseif y(r,1)>=eitceli & y(r,1)<eitcinc
       eitc(r)=min(eitcmax,(eitcmax-eitcout*(y(r,1)-eitceli)));
    else 
       eitc(r)=0;
    end  
    % Defining net income if agent is employed 
    if y(r,1)>0.08
        T(r)=tax(r)+ss(r)-eitc(r);
    else
        T(r)=-unem;
    end
    % Optimal subsidy
    L(r)=b(r)-y(r)+T(r)+(1-s(r))*w*(1-h(r));
    lump(r)=L(r)*(10*n*50/1000);
    atax(r)=T(r)*(10*n*50/1000);
end

subUSA0=mat2str(subUSA(firstwork:N))

atax0=mat2str(atax)
lump0=mat2str(lump)
sub0=mat2str(sub)

earn0=mat2str(earn)
earnings0=mat2str(earnings)
income=[zeros(firstwork-1,1);earn]';

%break

%% Graph
% Quasi-Linear Utility with Log Social Welfare
% Computing US Child Allowances using baseline optimal earnings
atax0=[-0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 -0.556 0.0134451562200403 0.0143167484884246 0.0147413473981951 0.015749191634931 0.0158955445950374 0.016204464232263 0.0164856496246634 0.0170940365508586 0.0171399596490125 0.0183984958031989 0.0204344172733611 0.0205387807849317 0.0207189469292297 0.0207589899639649 0.0276185645523525 0.04924757256445 0.132147868393234 0.156400710154072 0.402295792554336 0.404405033484957 0.568577742257106 0.572130606482322 0.58337613168841 1.41111765572136 1.53386403085148 1.53534024757255 3.02123117802316 3.25554453685014 3.25829015870573 4.19640809107142 4.63307218264965 6.94007815403328 8.09021266438683 15.674877434368 22.7935699671171 50.1973507009378];
atax2=[-5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -5.5 -1.22927142583225 -1.30895986179882 -1.34778033354927 -1.43992609233654 -1.45330693440341 -1.48155101552119 -1.50725939425494 -1.56288334179279 -1.56708202505258 -1.68214818772104 -1.86828957927873 -1.8778313860509 -1.89430371924386 -1.89796479670536 -1.93847425820941 -2.0249902902578 -2.35659147357294 -2.42521090894123 -2.92799957582995 -2.93231240073601 -3.16039827494064 -3.16483069814559 -3.17886020327599 -3.98311995143193 -3.93872709739934 -3.93807100107887 -2.90645199292732 -2.52077665490629 -2.51612103523811 -0.925399323835424 -0.184968907681025 4.57301472945497 6.59021266438683 13.174877434368 20.2935699671171 47.3973507009378];
Alump=atax0-atax2;
subUSA=[0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.701 0.536 0.536 0.536 0.516 0.506 0.24 0.21 0.2 0.2 0.2];
income=[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 3.84147320572579 4.09049956812132 4.21181354234146 4.49976903855169 4.54158417001067 4.62984692350372 4.7101856070467 4.88401044310247 4.8971313282893 5.25671308662825 5.83840493524603 5.86822308140905 5.91969912263705 5.93113998970425 6.05773205690441 6.32809465705562 7.36434835491543 7.57878409044135 9.1499986744686 9.16347625230005 9.8762446091895 9.89009593170496 9.93393813523746 13.1610006071008 13.7159112825082 13.7241124865142 19.233613817492 20.2523675515223 20.264305037851 24.3430786568322 26.2416181854333 36.2720789305795 41.2726637582036 54.5829619223274 76.1547574761124 158.111966789064];
% Baseline optimal
lumpB=[6.88958800275866 6.89069701471724 6.89255891812952 6.8948185781009 6.89734070368618 6.89992788401014 6.90242858289603 6.90473213274534 6.90678128435326 6.90850715871076 6.90980052872145 6.91056030137146 6.90713860341548 6.89313473287699 6.890777008636 2.17647000095626 1.97369768685818 1.95448730280615 1.94159426801746 1.94025735202132 1.93703109117324 1.93304768409301 1.92336663352127 1.9221763402861 1.89250678453775 1.86049745851045 1.85921250028418 1.85550018324353 1.85429681719589 1.84273504627434 1.81796011942714 1.73355353699263 1.72542250722318 1.76587962151248 1.7666223082103 1.83738516906155 1.83897247271067 1.84141197760534 2.06999264261311 2.11273750382761 2.11282368029259 2.724205613359 2.86223933857182 2.86356989029572 3.13871066109534 2.95912578795933 1.24042916593482 0.570798649777122 3.21794327153636 2.84003285156325 9.00352179844375];
subB=[0.816766893607011 0.830100189900356 0.827522494080677 0.817804746127613 0.816358897686596 0.813137108969954 0.8101543827611 0.803498097873389 0.803036327737833 0.788971403927853 0.765984188298802 0.764818943166372 0.762799780875555 0.762365738729361 0.757369071229304 0.746641179255163 0.705375162816311 0.696841412212652 0.634172534396621 0.633640540021373 0.605202517780569 0.604656141450922 0.602917579245974 0.47408000962982 0.451926912657765 0.45160471816837 0.231578122525279 0.190892716614852 0.19041878457338 0.0275142125692598 0 0 0 0 0 0];
earnB=[3.84147320572579;4.09049956812132;4.21181354234146;4.49976903855169;4.54158417001067;4.62984692350372;4.7101856070467;4.88401044310247;4.8971313282893;5.25671308662825;5.83840493524603;5.86822308140905;5.91969912263705;5.93113998970425;6.05773205690441;6.32809465705562;7.36434835491543;7.57878409044135;9.1499986744686;9.16347625230005;9.8762446091895;9.89009593170496;9.93393813523746;13.1610006071008;13.7159112825082;13.7241124865142;19.233613817492;20.2523675515223;20.264305037851;24.3430786568322;26.2416181854333;36.2720789305795;41.2726637582036;54.5829619223274;76.1547574761124;158.111966789064];
earningsB=[4.8628600918165e-07;0.000312717191500251;0.0011621832450945;0.00167367890114293;0.00223447339487019;0.00304379966257918;0.00415620826876371;0.00530884188725298;0.00694448218999454;0.00931949568874446;0.0139546761360431;0.0203163675944693;0.0853603804425694;0.266000346769765;0.293652631099368;3.84147320572579;4.09049956812132;4.21181354234146;4.49976903855169;4.54158417001067;4.62984692350372;4.7101856070467;4.88401044310247;4.8971313282893;5.25671308662825;5.83840493524603;5.86822308140905;5.91969912263705;5.93113998970425;6.05773205690441;6.32809465705562;7.36434835491543;7.57878409044135;9.1499986744686;9.16347625230005;9.8762446091895;9.89009593170496;9.93393813523746;13.1610006071008;13.7159112825082;13.7241124865142;19.233613817492;20.2523675515223;20.264305037851;24.3430786568322;26.2416181854333;36.2720789305795;41.2726637582036;54.5829619223274;76.1547574761124;158.111966789064];
% Baseline Pareto improving
lumpBP=[5.3477326772757 5.3503116621015 5.35178255646269 5.35237456714816 5.35314408552828 5.35410786848179 5.3550870059292 5.35597156724676 5.35691876838788 5.35759758870648 5.3563906179682 5.34809959611007 0.620130826839583 0.641642753403862 0.652796861475053 0.68572365137295 0.719600161024148 0.753540089111189 0.808334503140082 0.838743426583461 0.887594088766341 0.961099274013371 1.07383138844257 1.1734123405803 1.33222556813993 1.54074566784446 1.71065157076584 2.02693935324343 2.43032043896808 3.64383217900173 4.37231357081673 4.38782164344009 4.39166443692773 4.53984558390566 4.77750133522904 5.11942718101442 5.52306149650439 5.75433912445592 5.80483752424657 5.80624443597987 5.80659559418329 6.30866584389988 6.43296796904803 6.43395403701779 6.64187820135646 6.49129593375524 4.70504110610861 7.42033087792318 7.08404750776359 6.31065791867492 12.1441305173428];
subBP=[0.83044232777219 0.823292553116087 0.820255190371709 0.811302286927114 0.802712180544282 0.794368127408511 0.781612418893973 0.775030132775495 0.764306619554791 0.752219157121076 0.735692177000326 0.721915295220055 0.70018778676066 0.680773639014393 0.665090528531879 0.637796553572036 0.608779180112954 0.537521180184472 0.49795380541065 0.49704903351904 0.49677386486565 0.483785552866352 0.462147304444369 0.422126737198954 0.376453688747652 0.347504167667374 0.339030945153983 0.338767103243186 0.33867253569369 0.2818959396505 0.23102392225693 0.230479464125375 0.0511159375943697 0 0 0 0 0 0];
earnBP=[4.16710886148275;4.38412060850828;4.46769945714998;4.70134071150304;4.92131771203391;5.13328183943652;5.45547391207923;5.62142872845895;5.89124682396502;6.19500332062863;6.60988389396006;6.95551161304985;7.50029957205385;7.98690728570608;8.37990451682388;9.0637219738795;9.79058874873444;11.5752371170149;12.5660741488363;12.5887284330324;12.5956004844514;12.9208254823866;13.462651277537;14.4647448372078;15.608330333951;16.3331802597202;16.5453567754174;16.5519976053738;16.5544233323498;17.9759336014692;19.2496190977286;19.2632933040794;23.75387608295;26.1816241207865;37.0246643840402;43.7070799085634;52.6802758468411;74.4536506467702;158.112764469604];
earningsBP=[6.87361939130643e-08;0.000134497468100571;0.00170377150451738;0.0035421414630017;0.00688442756046569;0.012664476696648;0.0213390797353967;0.0335858602196561;0.0550970693369753;0.0937346150780523;0.195737414382203;0.435675011225528;4.16710886148275;4.38412060850828;4.46769945714998;4.70134071150304;4.92131771203391;5.13328183943652;5.45547391207923;5.62142872845895;5.89124682396502;6.19500332062863;6.60988389396006;6.95551161304985;7.50029957205385;7.98690728570608;8.37990451682388;9.0637219738795;9.79058874873444;11.5752371170149;12.5660741488363;12.5887284330324;12.5956004844514;12.9208254823866;13.462651277537;14.4647448372078;15.608330333951;16.3331802597202;16.5453567754174;16.5519976053738;16.5544233323498;17.9759336014692;19.2496190977286;19.2632933040794;23.75387608295;26.1816241207865;37.0246643840402;43.7070799085634;52.6802758468411;74.4536506467702;158.112764469604];

figure(5) 
orient landscape
hold on
subplot(2,3,2)
hold on
plot (earningsB,lumpB,'-k','LineWidth',1.5);
hold on
plot (earningsBP,lumpBP,'--','LineWidth',1.5,'Color',[0.8 0 0.8]);
hold on
plot (income,Alump,'bo','MarkerSize',2);
hold on
set(gca,'FontSize',9)
title('(b) Child Allowances','fontsize',9)
ylabel('Amount ($000)','fontsize',9)
xlabel('Earnings ($000)','fontsize',9)
subplot(2,3,1)
hold on
h1=plot (earnB,subB,'-k','LineWidth',1.5);
hold on
plot (earnBP,subBP,'--','LineWidth',1.5,'Color',[0.8 0 0.8]);
hold on
h2=plot (earnB,subUSA,'bo','MarkerSize',2);
hold on
set(gca,'FontSize',9)
title('(a) Child Care Subsidy','fontsize',9)
ylabel('Rate','fontsize',9)
xlabel('Earnings ($000)','fontsize',9)
subplot(2,3,6)
plot (income,atax0,'ob','MarkerSize',3);
hold on
plot ([0 170],[0 0],':k','LineWidth',1);
hold on
set(gca,'FontSize',9)
title('(e) US Net Taxes','fontsize',9)
ylabel('Amount ($000)','fontsize',9)
xlabel('Earnings ($000)','fontsize',9)
subplot(2,3,5)
hold on
plot (earningsB,lumpB,'-k','LineWidth',1.5);
hold on
plot (earningsBP,lumpBP,'--','LineWidth',1.5,'Color',[0.8 0 0.8]);
hold on
plot (income,Alump,'bo','MarkerSize',2);
hold on
plot ([0 170],[0 0],':k','LineWidth',1);
hold on
set(gca,'FontSize',9)
title('(d) Child Allowances','fontsize',9)
ylabel('Amount ($000)','fontsize',9)
xlabel('Earnings ($000)','fontsize',9)
hold on
subplot(2,3,4)
hold on
plot (earnB,subB,'-k','LineWidth',1.5);
hold on
plot (earnBP,subBP,'--','LineWidth',1.5,'Color',[0.8 0 0.8]);
hold on
plot (earnB,subUSA,'bo','MarkerSize',2);
hold on
set(gca,'FontSize',9)
title('(c) Child Care Subsidy','fontsize',9)
ylabel('Rate','fontsize',9)
xlabel('Earnings ($000)','fontsize',9)
legend('Baseline','Baseline Pareto','USA')
hold off



